/**
 * generated by Xtext 2.13.0
 */
package com.javadude.dsl5.generator;

import com.google.common.collect.Iterators;
import com.javadude.dsl5.gothicSecurityDsl.Action;
import com.javadude.dsl5.gothicSecurityDsl.Command;
import com.javadude.dsl5.gothicSecurityDsl.Event;
import com.javadude.dsl5.gothicSecurityDsl.Reset;
import com.javadude.dsl5.gothicSecurityDsl.State;
import com.javadude.dsl5.gothicSecurityDsl.StateMachine;
import com.javadude.dsl5.gothicSecurityDsl.Test;
import com.javadude.dsl5.gothicSecurityDsl.Transition;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class GothicSecurityDslGenerator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    final StateMachine machine = IteratorExtensions.<StateMachine>head(Iterators.<StateMachine>filter(resource.getAllContents(), StateMachine.class));
    fsa.generateFile("Test7.kt", this.generateTest(machine));
  }
  
  public CharSequence generateTest(final StateMachine stateMachine) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("// WARNING - THIS FILE HAS BEEN GENERATED. DO NOT EDIT!!!");
    _builder.newLine();
    _builder.append("package dsl5");
    _builder.newLine();
    _builder.newLine();
    _builder.append("// initial, object-based implementation");
    _builder.newLine();
    _builder.append("class Test7 {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("companion object {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("@JvmStatic");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("fun main(args: Array<String>) {");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("// CONFIGURATION");
    _builder.newLine();
    {
      EList<Event> _events = stateMachine.getEvents();
      for(final Event event : _events) {
        _builder.append("\t\t\t");
        _builder.append("val ");
        String _name = event.getName();
        _builder.append(_name, "\t\t\t");
        _builder.append(" = Event(\"");
        String _name_1 = event.getName();
        _builder.append(_name_1, "\t\t\t");
        _builder.append("\", \"");
        String _code = event.getCode();
        _builder.append(_code, "\t\t\t");
        _builder.append("\")");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    {
      EList<Command> _commands = stateMachine.getCommands();
      for(final Command command : _commands) {
        _builder.append("\t\t\t");
        _builder.append("val ");
        String _name_2 = command.getName();
        _builder.append(_name_2, "\t\t\t");
        _builder.append(" = Command(\"");
        String _name_3 = command.getName();
        _builder.append(_name_3, "\t\t\t");
        _builder.append("\", \"");
        String _code_1 = command.getCode();
        _builder.append(_code_1, "\t\t\t");
        _builder.append("\")");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t\t\t");
    _builder.newLine();
    {
      EList<State> _states = stateMachine.getStates();
      for(final State state : _states) {
        _builder.append("\t\t\t");
        _builder.append("val ");
        String _name_4 = state.getName();
        _builder.append(_name_4, "\t\t\t");
        _builder.append(" = State()");
        _builder.newLineIfNotEmpty();
        {
          EList<Action> _actions = state.getActions();
          for(final Action action : _actions) {
            _builder.append("\t\t\t");
            String _name_5 = state.getName();
            _builder.append(_name_5, "\t\t\t");
            _builder.append(".actions.add(");
            String _name_6 = action.getCommand().getName();
            _builder.append(_name_6, "\t\t\t");
            _builder.append(")");
            _builder.newLineIfNotEmpty();
          }
        }
        _builder.append("\t\t\t");
        _builder.newLine();
      }
    }
    _builder.append("\t\t\t");
    _builder.newLine();
    {
      EList<State> _states_1 = stateMachine.getStates();
      for(final State state_1 : _states_1) {
        {
          EList<Transition> _transitions = state_1.getTransitions();
          for(final Transition transition : _transitions) {
            _builder.append("\t\t\t");
            String _name_7 = state_1.getName();
            _builder.append(_name_7, "\t\t\t");
            _builder.append(".transitions[");
            String _name_8 = transition.getEvent().getName();
            _builder.append(_name_8, "\t\t\t");
            _builder.append("] = ");
            String _name_9 = transition.getTarget().getName();
            _builder.append(_name_9, "\t\t\t");
            _builder.newLineIfNotEmpty();
          }
        }
        _builder.append("\t\t\t");
        _builder.newLine();
      }
    }
    _builder.append("\t\t\t");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("val machine = StateMachine(");
    String _name_10 = stateMachine.getStartState().getName();
    _builder.append(_name_10, "\t\t\t");
    _builder.append(")");
    _builder.newLineIfNotEmpty();
    {
      EList<Reset> _resetEvents = stateMachine.getResetEvents();
      for(final Reset resetEvent : _resetEvents) {
        _builder.append("\t\t\t");
        _builder.append("machine.resetEvents.add(");
        String _name_11 = resetEvent.getEvent().getName();
        _builder.append(_name_11, "\t\t\t");
        _builder.append(")");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t\t\t");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("// test run");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("val controller = Controller(");
    String _name_12 = stateMachine.getStartState().getName();
    _builder.append(_name_12, "\t\t\t");
    _builder.append(", machine, CommandChannel())");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    {
      EList<Test> _tests = stateMachine.getTests();
      for(final Test test : _tests) {
        _builder.append("\t\t\t");
        _builder.append("println()");
        _builder.newLine();
        _builder.append("\t\t\t");
        _builder.append("println(\"TEST ");
        String _name_13 = test.getName();
        _builder.append(_name_13, "\t\t\t");
        _builder.append("\")");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t\t");
        _builder.append("println(\"======\")");
        _builder.newLine();
        {
          EList<Event> _events_1 = test.getEvents();
          for(final Event event_1 : _events_1) {
            _builder.append("\t\t\t");
            _builder.append("controller.handle(");
            String _name_14 = event_1.getName();
            _builder.append(_name_14, "\t\t\t");
            _builder.append(")");
            _builder.newLineIfNotEmpty();
          }
        }
        _builder.append("\t\t\t");
        _builder.newLine();
      }
    }
    _builder.append("\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
